#!/usr/bin/perl -w
# Tossed this together in about 15 minutes so don't expect it to be pretty!
# Recommend you run it under screen or tmux
# Requires the following packages: libwww-perl libdbd-sqlite3-perl sqlite3
use LWP::Simple;
use DBI;
use strict;
my %names;
my %old_names;
my %ontime;

# Configurable: How often to check online list, in seconds
my $interval = 5;

my $dbh = DBI->connect("dbi:SQLite:dbname=players.db") or die;
# No tables? No problem!
$dbh->do("create table if not exists log ('name' varchar(26), action integer, pos integer, time integer);");
$dbh->do("create table if not exists ontime ('name' varchar(26), ontime integer)");
# Want it faster? Do this after initial run: grep '# echo' logger.pl  |sed 's/#//' |bash
# Ignore the lines below:
# echo "create index ontimeidx on ontime (ontime);" | sqlite3 players.db
# echo "create index nidx on ontime (name);" |sqlite3 players.db
# echo "create index timeidx on log (time);" |sqlite3 players.db
# echo "create index nameidx on log (name);" |sqlite3 players.db

my $log = $dbh->prepare('INSERT INTO log VALUES(?, ?, ?, ?)');

while(1) {
  %old_names = %names;
  undef(%names);
  get_online_list();

  foreach(keys %names) {
    # Add to the ontime of everyone who's currently logged in
    if (defined($ontime{$_})) { $ontime{$_} = $ontime{$_} + $interval; }
    else { $ontime{$_} = 0; }

    # Figure out who has logged in in the past interval
    if (!defined($old_names{$_})) {
      $log->execute($_, 1, $names{$_}, time());
      print "Logged in: $_ $names{$_}\n";
    }
  }

  # Figure out who logged out
  foreach (keys %old_names) {
    if(!defined($names{$_})) {
      $log->execute($_, 0, $old_names{$_}, time());
      print "Logged out: $_ $old_names{$_}\n";
    }
  }

  # Save the ontimes every once in a while
  save_ontimes() if (time() % 300);

  sleep($interval);
}
	
sub get_online_list {
  my ($ok, $content, @lines, $pos);
  $content = get("http://server.themanaworld.org/online.txt") or return;
  $content =~ s/\r//;
  @lines = split(/\n/, $content);
  $pos = 0;
  foreach (@lines) {
    chomp;
    s/\s+//g;
    $ok++,next if (/----------/);
    next unless $ok;
    last if (/^$/ && $ok);
    $names{$_} = $pos++;
  }
}

# Why am I not using tied hashes? Too lazy to turn back now!
sub load_ontimes {
  my $sth = $dbh->prepare("SELECT * from ontime");
  $sth->execute;
  while (my @data = $sth->fetchrow_array()) {
    $ontime{$data[0]} = $data[1];
  }
}

sub save_ontimes {
  my $sth = $dbh->prepare("insert or replace into ontime values(?, ?)");
  foreach (keys %ontime) { $sth->execute($_, $ontime{$_}); }
}

